/*
	Header and include file for QCOPY and other files....
	(Include this in ALL files.....)

	This program was written using AZTEC C86, Not MicroS**t C.
	I have done everything possible to make things come out as
	universal as possible... I try to keep to the UNIX standards
	(a much more universal thing then any thing else...)

	Those things that are particular to AZTEC, are #ifdef'ed out...
	and message is put in it's place...
 */
#define	AZTEC_C86	/* I wrote this for AZTEC... */


/* Define this inside of MAIN.C ONLY!!!!!!!!!!! */
#ifdef	MAIN_MODULE
#define	EXTERNAL
#else
#define	EXTERNAL extern
#endif

/* Standard defines.... */
#define	YES	1
#define	NO	0
#define	TRUE	1
#define	FALSE	0


/* You might want to change this to your beeper... */
#define beep()	putchar(7)

/* Flags Used. */
EXTERNAL int VerifyDisk;	/* Do we re-read the disk to verify it? */
EXTERNAL int TotalDone;		/* How many disks have we made.. */
EXTERNAL int Drive_A_Valid;	/* Can we use Drive A? */
EXTERNAL int Drive_B_Valid;	/* And what about Drive B? */

/* Use this option with extream care... Usefull but dangerous... */
EXTERNAL int ignore_formated_disks;  

/* 
	this program talks to DOS and the BIOS via 

	sysint( interrupt, inregs, outregs )
	int interrupt;
	REGS *inregs, *outregs;

	This function RETURNS the flag register. 

	It is also quite a common utility function, most all compilers
	support it. at least the ones that I have seen....
*/

typedef struct	{
	int	AX, BX, CX, DX, SI, DI, DS, ES;
} REGS;

EXTERNAL REGS input_regs, output_regs;

/*
	The sysint() function returns the FLAG REGISTER, we are 
	to make life easier, we have a global var for the FLAGS.
	
	I do things like this:

	FLAGS = sysint( 0x13, &input_regs, &output_regs );
 */

EXTERNAL int FLAGS;		 

/* 
	To test the state of the CARRY flag, we have these two defines.. 
 */
#define	CARRY_SET	(FLAGS & 0x01)
#define	CARRY_CLEAR	(!CARRY_SET)

/*
	Disk Constants...
 */


#define	MAX_TRIES		3	/* how many times to RE-TRY things */
#define	BYTES_PER_SECTOR	512	/* disk particulars.. */
#define	SECTORS_PER_TRACK	9
#define	SIDES_PER_DISK		2
#define	TRACKS_PER_DISK		40

/*
	This holds the information for ONE track.
 */

typedef struct {
	struct {
		char data[ BYTES_PER_SECTOR * SECTORS_PER_TRACK ];
	} head[SIDES_PER_DISK];
} TRACK;

/*
	One track ends up being: 9216 Bytes long.
	It would be nice to make one HUGE array of tracks, but..
	not all compilers support HUGE things... So we just
	malloc() track and keep it here.

	NOTE: This *impiles* LARGE DATA MODEL!!!!!
 */

EXTERNAL TRACK *track[TRACKS_PER_DISK];

/*
	When you format the disk you need to pass the bios some things.
	This is the stuff, see formatd.c for more information...
 */

EXTERNAL struct {
	struct {
 		struct {
			char cyl, head, rec, num;
		} format_record[SECTORS_PER_TRACK];
	} side[SIDES_PER_DISK];
} trk_fmt[TRACKS_PER_DISK];

