#include <stdio.h>
#include <time.h>
#include "externs.h"

/* this file may have to be changed for your compiler.....

The only function you must change is GET_SECONDS(), it must return
the current SECONDS, (ie read the clock and return the seconds)

*/

timer_ran_out( setup )
int setup;
{
static int last_seconds;

    if( setup ){
        last_seconds = GET_SECONDS();
        return 0;
    } else {
        if( last_seconds == GET_SECONDS() )
            return 0;
        else {
            last_seconds = GET_SECONDS();
            return 1;
        }
    }
}

#ifdef    AZTEC_C86

/*
I am using AZTEC C86, your c compiler may not like this.....


    This is how I do it in the most universal method I can find..
    (it's alot easier if I could use some of the aztec functions...)

Step 1:  Read the clock via a call to time(), 
         On UNIX (and aztec) time() returns a time_t.
Step 2:  The function localtime() wants the ADDRESS of a time_t
         it then breaks this up into a tm struct and returns the
         address of that struct.
Step 3:  Return the value of the tm_secs element (the seconds..)

Note:    I use local_time()->tm_secs, it's legal, I only need to
         use the struct once, rather then make a struct ptr, just
         use the result of the function call, it works...

         in most cases, the time_t is defined in <types.h> as a long
*/

static GET_SECONDS()
{
time_t time();
time_t work;
struct tm *localtime();

    work = time( (time_t *)0 ); /* tell time() to RETURN it.. */
    return localtime(&work)->tm_sec;
}    

#else

error - You must write a GET_SECONDS() function here.....!!!!!!

#endif

